<template>
  <div class="crowdflash-canvas">
    <div class="color" :style="colorStyle"></div>
    <div class="text">
      <p :style="{'font-size': `${fontSize}vw`}">{{ textItems[textId] }}</p>
    </div>
    <button
      class="fullscreen"
      :style="colorStyle"
      v-if="!isIphone"
      @click="handleFullscreenButton"
    >
      <svg
        xmlns="http://www.w3.org/2000/svg"
        width="2em"
        height="2em"
        viewBox="0 0 448 512"
        aria-hidden="true"
        data-prefix="fal"
        data-icon="expand"
        class="svg-inline--fa fa-expand fa-w-14"
      >
        <path
          fill="currentColor"
          d="M0 180V56c0-13.3 10.7-24 24-24h124c6.6 0 12 5.4 12 12v8c0 6.6-5.4 12-12 12H32v116c0 6.6-5.4 12-12 12h-8c-6.6 0-12-5.4-12-12zM300 32h124c13.3 0 24 10.7 24 24v124c0 6.6-5.4 12-12 12h-8c-6.6 0-12-5.4-12-12V64H300c-6.6 0-12-5.4-12-12v-8c0-6.6 5.4-12 12-12zm148 300v124c0 13.3-10.7 24-24 24H300c-6.6 0-12-5.4-12-12v-8c0-6.6 5.4-12 12-12h116V332c0-6.6 5.4-12 12-12h8c6.6 0 12 5.4 12 12zM148 480H24c-13.3 0-24-10.7-24-24V332c0-6.6 5.4-12 12-12h8c6.6 0 12 5.4 12 12v116h116c6.6 0 12 5.4 12 12v8c0 6.6-5.4 12-12 12z"
        ></path>
      </svg>
    </button>
  </div>
</template>

<script>
import { nextTick } from 'vue';

const proto = process.env.VUE_APP_WS_PROTO;
const host = process.env.VUE_APP_WS_HOST;
const port = Number(process.env.VUE_APP_WS_PORT);
const path = process.env.VUE_APP_WS_PATH;

const userAgent = window.navigator.userAgent.toLowerCase();

const CONNECT_RETRIES = process.env.VUE_APP_CONNECT_RETRIES;
const CONNECT_DELAY = process.env.VUE_APP_CONNECT_DELAY;
let currentRetries = CONNECT_RETRIES;

export default {
  name: 'App',
  props: ['id'],
  inject: ['noSleep'],
  data() {
    return {
      color: {
        red: 0,
        green: 0,
        blue: 0,
      },
      textId: 0,
      textItems: [],
      fontSize: 10,
    };
  },
  computed: {
    colorStyle() {
      return {
        backgroundColor: `rgb(${ this.color.red }, ${ this.color.green }, ${ this.color.blue })`,
      };
    },
    isIphone() {
      return userAgent.indexOf('windows') === -1 && userAgent.indexOf('iphone') !== -1;
    },
  },
  methods: {
    async increaseFontSize() {
      const element = document.querySelector('.text');
      this.fontSize++;

      // Wait for text to be rendered before updating the size again
      await nextTick();

      if (element.scrollWidth > element.clientWidth || element.scrollHeight > element.clientHeight) {
        this.fontSize--;
        return;
      }
      await this.increaseFontSize();
    },
    handleFullscreenButton() {
      console.log('fullscreen button enabled noSleep:');
      this.noSleep.enable();
      console.log(this.noSleep);
      this.toggleFullscreen();
    },
    toggleFullscreen() {
      const element = document.documentElement;

      // if already full screen; exit
      // else go fullscreen
      if (
        document.fullscreenElement ||
        document.webkitFullscreenElement ||
        document.mozFullScreenElement ||
        document.msFullscreenElement
      ) {
        if (document.exitFullscreen) {
          document.exitFullscreen();
        } else if (document.mozCancelFullScreen) {
          document.mozCancelFullScreen();
        } else if (document.webkitExitFullscreen) {
          document.webkitExitFullscreen();
        } else if (document.msExitFullscreen) {
          document.msExitFullscreen();
        }
      } else {
        if (element.requestFullscreen) {
          element.requestFullscreen({navigationUI: 'hide'});
        } else if (element.mozRequestFullScreen) {
          element.mozRequestFullScreen();
        } else if (element.webkitRequestFullscreen) {
          element.webkitRequestFullscreen(Element.ALLOW_KEYBOARD_INPUT);
        } else if (element.msRequestFullscreen) {
          element.msRequestFullscreen();
        }
      }
    },
    connectWebsocket() {
      const ws = new WebSocket(
        proto + '://' + host + (port > 0 ? ':' + port : '') + '/' + path + '/' + this.id,
      );
      ws.onmessage = ({data}) => {
        const payload = JSON.parse(data);
        if (payload.type === 'textUpdate') {
          this.textItems = payload.textItems;
        } else if (payload.type === 'colorUpdate') {
          this.color = payload.color;
          this.textId = payload.textId;
        } else {
          console.error('Unsupported websocket payload type. Received', payload);
        }
      };

      ws.onopen = () => {
        currentRetries = CONNECT_RETRIES;
        console.log('Connection successful.');
      };

      ws.onclose = (e) => {
        console.log(
          'Socket is closed. Reconnect will be attempted in 2 seconds.',
          e.reason,
        );
        if (currentRetries > 0) {
          currentRetries--;
          setTimeout(() => {
            this.connectWebsocket();
          }, CONNECT_DELAY * 1000);
        }
      };

      ws.onerror = (e) => {
        console.error(
          'Socket encountered error: ',
          e.message,
          'Closing socket',
        );
        ws.close();
      };
    },
  },
  created() {
    try {
      this.connectWebsocket();
    } catch (err) {
      console.err(err);
    }

    this.noSleep.enable();
  },
  unmounted() {
    this.noSleep.disable();
  },
  mounted() {
    Array.from(document.querySelectorAll('style')).forEach((sheet) => {
      if (sheet.textContent?.includes('-webkit-filter: hue-rotate(180deg) invert(100%) !important;')) {
        sheet.parentNode?.removeChild(sheet);
      }
    });
  },
  watch: {
    async textId(newTextId) {
      if (this.textItems[newTextId] !== undefined && this.textItems[newTextId].trim().length > 0) {
        this.fontSize = 10;
        await this.increaseFontSize();
      }
    },
    async textItems(newTextItems) {
      if (newTextItems[this.textId] !== undefined && newTextItems[this.textId].trim().length > 0) {
        this.fontSize = 10;
        await this.increaseFontSize();
      }
    },
  },
};
</script>

<style>
.crowdflash-canvas {
  position: fixed;
  width: 100vw;
  height: 100vh;
  inset: 0;
}

.color {
  width: 100%;
  height: 100%;
}

.text {
  position: absolute;
  inset: 0;
  width: 100%;
  margin: 1em 0 5em;
  display: flex;
  align-items: center;
  justify-content: center;
  text-align: center;
}

.text p {
  color: white;
}

button.fullscreen {
  position: absolute;
  top: 1em;
  right: 1em;
  padding: 1em;
  border: none;
  border-radius: 100%;
  -webkit-filter: invert(100%);
  filter: invert(100%);
  cursor: pointer;
  opacity: 0.4;
}

@media (hover: hover) {
  button.fullscreen {
    opacity: 0.3;
  }

  button.fullscreen:hover {
    opacity: 0.7;
  }
}

button.fullscreen svg {
  display: block;
  color: white;
}
</style>
